/*
 *  $Id: anchor.js,v 1.8 2009/01/06 22:11:20 pvk Exp $
 *
 *  This file is part of the OpenLink Software Ajax Toolkit (OAT) project.
 *
 *  Copyright (C) 2005-2009 OpenLink Software
 *
 *  See LICENSE file for details.
 */

OAT.AnchorData = {
	active:false,
	window:false
}

OAT.Anchor = {
		
	appendContent:function(options) {
		if (options.content && options.window) {
			if (typeof(options.content) == "function") { options.content = options.content(); }
			var win = options.window;
			OAT.Dom.clear(win.dom.content);
			win.dom.content.appendChild(options.content);
			OAT.Anchor.fixSize(win);
		}
	},

	/** adjust width and height if content overflows container depending on block or inline element inside */
	fixSize:function (win) {
			return;
		 	/* the code of this function will be removed: in firefox, we can do the same with CSS */

			/* wait to finish all ajax calls */
			setTimeout(function(){
				if (OAT.AJAX.requests.length) {
					OAT.Anchor.fixSize(win);
				} else {
					var height = OAT.Dom.getWH(win.dom.content)[1];
					while (OAT.Dom.getWH(win.dom.content)[1]+50 > OAT.Dom.getWH(win.dom.container)[1]) {
						if (OAT.Dom.getWH(win.dom.container)[0] < 650)
							win.dom.container.style.width = (OAT.Dom.getWH(win.dom.container)[0]+100)+'px';
						if (height == OAT.Dom.getWH(win.dom.content)[1]) {
							win.dom.container.style.width = (OAT.Dom.getWH(win.dom.container)[0]-100)+'px';
							/* now adding scrollbar when too large window */
							if (OAT.Dom.getWH(win.dom.content)[1] > 400) {
								win.dom.content.style.height = '400px';
								win.dom.content.style.overflow = 'auto';
							}
							win.dom.container.style.height = (OAT.Dom.getWH(win.dom.content)[1]+40)+'px';
							break;
						}
						height = OAT.Dom.getWH(win.dom.content)[1];
					}
				}
			}, 50 );
		},

	assign:function(element,paramsObj) {

		var elm = $(element);
		var options = {
			href:false, /* url to be fetched */
			newHref:"javascript:void(0)",
			content:false, /* node or function to be inserted */
			status:false, /* window status */
			title:false, /* window title */
			activation:"hover",
			width:450,
			height:false, /* false is 'auto' */
			elm:elm, /* anchor node */
			window:false, /* what should be displayed */
			arrow:false, /* what should be displayed */
			type:OAT.WinData.TYPE_ODS,
			visibleButtons:"cr",
			enabledButtons:"cr"
		};
		for (var p in paramsObj) { options[p] = paramsObj[p]; }

		if (options.activation!=="click")
			OAT.Dom.attach(window.top.getBrowser().selectedBrowser.contentDocument.getElementsByTagName('body')[0],"click",function(event) {
				var checkIfClickedOutside = function(elem) {
					if (elem.tagName=='BODY' || elem.tagName=='HTML')
						return true;
					if (elem.className.match(/^oat_win.+_container$/)) {
						return false;
					} else {
						return checkIfClickedOutside(elem.parentNode);
					}
				}
				if ( checkIfClickedOutside(event.target) ) {
					var opened = $$("oat_win_container");
					for (i in opened) {
						if (!opened[i].tagName) continue;
						OAT.Anchor.close(opened[i], true);
					}
				}
			});

		var win = new OAT.Win( {
			outerWidth:options.width,
			outerHeight:options.height,
			title:"OpenLink LinkedData - Loading...",
			type:options.type,
			status:options.status,
			visibleButtons:options.visibleButtons,
			enabledButtons:options.enabledButtons,
			template:options.template	} );
		function checkOver() {
			var opts = OAT.AnchorData.active;
			if (!opts) { return; }
			if (opts.activation == "hover") { opts.endClose(); }
		}
		function checkOut() {
			var opts = OAT.AnchorData.active;
			if (!opts) { return; }
			if (opts.activation == "hover") { opts.startClose(); }
		}
		OAT.Dom.attach(win.dom.container,"mouseover",checkOver);
		OAT.Dom.attach(win.dom.container,"mouseout",checkOut);
		var arrow = OAT.Dom.create("div",{});
		OAT.Dom.append([win.dom.container,arrow]);
		options.arrow = arrow;
		options.window = win;

		win.close = function() { OAT.Dom.hide(win.dom.container); }
		win.onclose = win.close;
		win.close();

		options.stat = 0; /* not initialized */
		if (!options.href && 'href' in elm) { options.href = elm.href; } /* if no oat:href provided, then try the default one */
		if (elm.tagName.toString().toLowerCase() == "a") { OAT.Dom.changeHref(elm,options.newHref); }

		options.displayRef = function(event) {

			var prefs = Components.classes["@mozilla.org/preferences-service;1"].
						getService(Components.interfaces.nsIPrefBranch);

			if (!prefs.getBoolPref("extensions.linkeddata.enabled"))
				return;

			OAT.AJAX.abortAll();

			var opened = $$("oat_win_container");
			for (i in opened) {
				if (!opened[i].tagName) continue;
				OAT.Anchor.close(opened[i], true);
			}

			var win = options.window;
			win.hide(); /* close existing window */
			OAT.AnchorData.active = options;
			var pos = OAT.Dom.eventPos(event);
			OAT.AnchorData.window = win; /* assign last opened window */

			OAT.Anchor.appendContent(options);
			
			win.dom.container.style.opacity = 0;
			var a = new OAT.AnimationOpacity(win.dom.container,{delay:1,opacity:0.9});
			a.start();
			win.show();

			options.anchorTo(pos[0],pos[1]);

/***********************************/
/** MAIN CODE OF LINKEDDATA BEGIN **/
/***********************************/

			if (prefs.getBoolPref("extensions.linkeddata.linksubmitting"))
				win.dom.content.appendChild(OAT.Moz.LinkedData.getSubmittingLinksHTML(options.uri));

			var loading = OAT.Dom.create("img");
			loading.src = "chrome://linkeddata/content/img/throbber.gif";
			win.dom.content.appendChild(loading);

			var liclicked; /* li element which will be expanded */
			var throbber;
			var pragma = prefs.getCharPref("extensions.linkeddata.spongeroptions")
			var endpoint = prefs.getCharPref("extensions.linkeddata.defaultendpoint");
			var rdfb = prefs.getBoolPref("extensions.linkeddata.rdfb");

			var finishLoading = function(uri) {
				OAT.Dom.hide(loading);
				win.dom.title.wrappedJSObject.getElementsByTagName('span')[0].innerHTML = "OpenLink LinkedData - " + uri;
			}

			var callback = function(data) {
				finishLoading(options.uri);
				var result = buildTree( data.getElementsByTagName("uri") );
				win.dom.content.innerHTML += result;
				options.anchorTo(pos[0],pos[1]); /* after adding arrows, window can be shifted a bit */
				if (!$("oat_linkeddata_resultset").wrappedJSObject) return;
				var windows = $$("oat_linkeddata_resultset");
				for (j in windows) { /* we must each time reassign events because of innerHTMLs */
					if (!windows[j].wrappedJSObject) continue;
					lis = windows[j].wrappedJSObject.getElementsByTagName('li');
					for (i in lis) {
						if (lis[i].childNodes) OAT.Dom.attach(lis[i].childNodes[1],"click",subtree);
					}
				}
			}

			var subtree = function(event) {
				var uri = event.target.parentNode.childNodes[2].href;
				liclicked = event.target.parentNode;
				if (liclicked.getElementsByTagName('ul').length) {
					liclicked.removeChild(liclicked.getElementsByTagName('ul')[0]);
					return;
				}
				var ajaxopts = {
					auth:OAT.AJAX.AUTH_NONE,
					type:OAT.AJAX.TYPE_XML,
					onerror:function(request) {
						liclicked.innerHTML += "<ul onclick=\"this.parent.removeChild(this);\"><li>Failed to retrieve linked data. HTTP Error " + request.getStatus() + "</li></ul>";
					}
				}

				OAT.AJAX.GET(endpoint+"?default-graph-uri="+uri+"&should-sponge="+pragma+"&query=select+%3FObjectID+%3FProperty+%3FPropertyValue%0D%0Awhere+%7B%7B%3C"+uri+"%3E+%3FProperty+%3FPropertyValue%7D+union+%7B%3FObjectID+%3FProperty+%3C"+uri+"%3E%7D%7D+&format=application%2Fsparql-results%2Bxml&debug=on", false, callbacksub, ajaxopts);
			}

			/** insert results into html */
			var callbacksub = function(data) {
				var result = buildSubTree( data.getElementsByTagName("result") );
				liclicked.innerHTML += result;
				OAT.Dom.attach(liclicked.childNodes[0],"click",subtree);
				options.anchorTo(pos[0],pos[1]); /* after adding arrows, window can be shifted a bit */
				OAT.Anchor.fixSize(OAT.AnchorData.window);
			}

			var buildSubTree = function(uris) { /* returns node */
				if (!uris.length)
					return "<ul onclick=\"this.parent.removeChild(this);\"><li>Sorry, no Linked Data found for this resource</li></ul>";

				var result = '<ul class="oat_linkeddata_resultset">';
				result += '<li style="text-transformation:italic;color:#777;">';
				result += '<span class="oat_linkeddata_objid">Object ID</span>';
				result += '<span class="oat_linkeddata_prop">Property</span>';
				result += '<span class="oat_linkeddata_propval">Property value</span></li>';

				var lastpropval = '';
				var lastprop = '';
				var lastobjid = '';
				for (i in uris) {
					var prop = '';
					var propval = '';
					var objid = '';
					var propText = '';
					var propvalText = '';
					var objidText = '';

					elm1 = uris.item(i).getElementsByTagName('binding')[0];
					elm2 = uris.item(i).getElementsByTagName('binding')[1];

					if (elm1.getAttribute('name')=='Property') {
						prop = elm1.firstChild.firstChild.data;
					} else if (elm2.getAttribute('name')=='Property') { /* only Property can be first or second elem */
						prop = elm2.firstChild.firstChild.data;
					}
					var slash = prop.lastIndexOf("/");
					var hash = prop.lastIndexOf("#");
					var dot = prop.lastIndexOf(".");
					var idx = hash>0 ?  hash : (slash>dot ? slash : 0);
					var propText = idx>0 ? prop.substr(-(prop.length - ++idx )) : '' ;

					if (elm2.getAttribute('name')=='PropertyValue') {
						propval = elm2.firstChild.firstChild.data;
						if (elm2.firstChild.tagName=='literal') {
							propvalText = propval;
						} else {
							var slash = propval.lastIndexOf("/");
							var hash = propval.lastIndexOf("#");
							var dot = propval.lastIndexOf(".");
							var idx = hash>0 ?  hash : (slash>dot ? slash : 0);
							var propvalText = idx>0 ? propval.substr(-(propval.length - ++idx )) : '' ;
						}
					}
					if (elm1.getAttribute('name')=='ObjectID') {
						objid = elm1.firstChild.firstChild.data;
						var slash = objid.lastIndexOf("/");
						var hash = objid.lastIndexOf("#");
						var dot = objid.lastIndexOf(".");
						var idx = hash>0 ?  hash : (slash>dot ? slash : 0);
						var objidText = idx>0 ? objid.substr(-(objid.length - ++idx )) : '' ;
					}

					if (propval==lastpropval && prop==lastprop && objid==lastobjid) continue;
					lastpropval = propval;
					lastprop = prop;
					lastobjid = objid;

					if (propText.length>15) propText = propText.substr(0,15) + '...';
					if (propvalText.length>15) propvalText = propvalText.substr(0,15) + '...';
					if (objidText.length>15) objidText = objidText.substr(0,15) + '...';

					result += '<li>';
					
					result += '<span title="'+prop+'" class="oat_linkeddata_prop">';
					if (prop)
						result += '<a title="Open this link" href="' + prop + '"><img style="border:none;" src="' + 'chrome://linkeddata/content/img/RDF_xhtml.gif' + '" onclick="OAT.Anchor.close(this);"/></a>';
					result += propText + '</span>';

					result += '<span title="'+propval+'" class="oat_linkeddata_propval">';
					if (elm2.getAttribute('name')=='PropertyValue' && elm2.firstChild.tagName=='uri')
						result += '<a title="Open this link" href="' + propval + '"><img style="border:none;" src="' + 'chrome://linkeddata/content/img/RDF_xhtml.gif' + '" onclick="OAT.Anchor.close(this);"/></a>';
					result += propvalText + '</span>';

					result += '<span title="'+objid+'" class="oat_linkeddata_objid">';
					if (objid) {
						result += '<a title="Open this link" href="' + objid + '"><img style="border:none;" src="' + 'chrome://linkeddata/content/img/RDF_xhtml.gif' + '" onclick="OAT.Anchor.close(this);"/></a>';
					} else {
						result += '&nbsp';
					}
					result += objidText + '</span>';

					result += '</li>';
				}
				result += "</ul>";

				// zvetsit oknicko
				if (parseInt(win.dom.container.style.width) <= 420)
					win.dom.container.style.width = '420px';

				return result;
			}

			var buildTree = function(uris) { /* returns node */
				if (!uris.length)
					return "Sorry, no Linked Data found for this resource";
				var result = '<ul class="oat_linkeddata_resultset" id="oat_linkeddata_resultset">';
				var lasturi = '';
				for (i in uris) {
					var uri = uris.item(i).firstChild.data;
					if (uri==lasturi) continue;
					var lasturi = uri;

					var slash = uri.lastIndexOf("/");
					var hash = uri.lastIndexOf("#");
					var dot = uri.lastIndexOf(".");
					var idx = hash>0 ?  hash : (slash>dot ? slash : 0);

					xuri = uri.substring(0,idx);
					var type = idx>0 ? uri.substr(-(uri.length - ++idx )) : '' ;


					result += '<li><span class="oat_linkeddata_type">' + type + '</span><span class="oat_linkeddata_uri">' + xuri + '</span>';
					result += '<a title="Open this link" href="' + uri + '"><img style="border:none;" src="' + 'chrome://linkeddata/content/img/RDF_xhtml.gif' + '" ';
					result += 'onclick="OAT.Anchor.close(this);"/></a>';
					result += "</li>";
				}
				result += "</ul>";
				return result;
			}

			var ajaxopts = {
				auth:OAT.AJAX.AUTH_NONE,
				type:OAT.AJAX.TYPE_XML,
				onerror:function(request) {
					OAT.AnchorData.window.dom.content.innerHTML = "Failed to retrieve linked data. HTTP Error " + request.getStatus();
					OAT.AnchorData.window.show();
				}
			}

			if (rdfb) { /* show rdfb instead of returned data */
				finishLoading(options.uri);
				var div = OAT.Dom.create("div");
				div.id = 'rdfmini';
				var r = new OAT.RDFMini(div);
				win.dom.content.appendChild(div);
				r.search(options.uri);
				OAT.Anchor.fixSize(OAT.AnchorData.window);
				OAT.Dom.attach(div.getElementsByTagName('select')[0], "change", function() {
					OAT.Anchor.fixSize(OAT.AnchorData.window);
				});
			} else {
				if (options.uri.substr(-1)=="/") // workaround for the slash issue on sponger
					options.uri = options.uri.substr(0,options.uri.length-1);
				var q = endpoint + "?default-graph-uri="+options.uri+"&should-sponge="+pragma+"&query=select+distinct+*%0D%0Afrom++%3C"+options.uri+"%3E%0D%0Awhere+%7B%5B%5D+a+%3FEntity%7D%0D%0A&format=application%2Fsparql-results%2Bxml&debug=on";
				OAT.AJAX.GET(q, false, callback, ajaxopts);
			}

/***********************************/
/** MAIN CODE OF LINKEDDATA END   **/
/***********************************/
			
		}
		options.anchorTo = function(x_,y_) {
			var win = options.window;
			var fs = OAT.Dom.getFreeSpace(x_,y_); /* [left,top] */
			var dims = OAT.Dom.getWH(win.dom.container);

			if (fs[1]) { /* top */
				var y = y_ - 35 - dims[1];
				var className = 'bottom';
			} else { /* bottom */
				var y = y_ + 25;
				var className = 'top';
			}

			if (fs[0]) { /* left */
				var x = x_ + 20 - dims[0];
				className += 'right';
			} else { /* right */
				var x = x_ - 30;
				className += 'left';
			}

			if (x < 0) { x = 10; }
			if (y < 0) { y = 10; }

			OAT.Dom.addClass(options.arrow,"oat_anchor_arrow_"+className);
			win.moveTo(x,y);
		}
		options.closeRef = function(event) {
			if (options.closeFlag) {
				options.window.hide();
				OAT.AnchorData.active = false;
			}
		}
		options.close = function() {
			options.window.hide();
		}
		options.startClose = function() {
			options.closeFlag = 1;
			setTimeout(options.closeRef,100);
		}
		options.endClose = function() {
			options.closeFlag = 0;
		}

		switch (options.activation) {
			case "hover":
				OAT.Dom.attach(elm,"mouseover",options.displayRef);
				OAT.Dom.attach(elm,"mouseout",options.startClose);
				break;
			case "click":
				OAT.Dom.attach(elm,"click",options.displayRef);
				break;
			case "dblclick":
				OAT.Dom.attach(elm,"dblclick",options.displayRef);			
				break;
			case "focus":
				OAT.Dom.attach(elm,"focus",options.displayRef);
				OAT.Dom.attach(elm,"blur",options.close);
				break;
		}
	},

	close:function(elem, recursive) {
		elem = $(elem);
		if (!elem.className) return;
		if (elem.tagName=='BODY') return;
		if (elem.className.match(/^oat_win.+_container$/)) {;
			if (recursive) this.close(elem.parentNode);
		} else {
			this.close(elem.parentNode);
		}
	}
}
