if (!OAT.Moz) OAT.Moz = {};

OAT.Moz.LinkedData = {

	onLoad:function() {
		this.initialized = true;
		window.top.getBrowser().selectedBrowser.addEventListener("DOMContentLoaded", this.doLinks, false );
		// TODO: attach the event on the browser specified by tab in, not by selectedBrowser. 
		// this fails when opening new tab which is not selected immediately
	},

	prefs:function() {
		window.open('chrome://linkeddata/content/prefs.xul', 'ExtensionListOptions', 'centerscreen, chrome, resizable');
	},

	doLinks:function() { /* applend a++ onto each hyperlink */

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var enabled = prefs.getBoolPref("extensions.linkeddata.enabled");
		if (!enabled) return;

		OAT.Style.include("chrome://linkeddata/content/linkeddata.css");
		var links = window.top.getBrowser().selectedBrowser.contentDocument.getElementsByTagName('a');

		var scope = prefs.getCharPref("extensions.linkeddata.scope");

		for (i in links) {
			/* we are not interested in <a name> and javascript or mailto links */
			if (links[i].href) if (links[i].href.substring(0,10)!='javascript' && links[i].href.substring(0,6)!='mailto') {
				if (scope=='all') {
					OAT.Moz.LinkedData.doLink(links[i]);
				} else if (OAT.Moz.LinkedData.isInParagraph(links[i])) { /* scope = paragraph */
					OAT.Moz.LinkedData.doLink(links[i]);
				}
			}
		}
	},

	isInParagraph:function(lnk) {
		if (lnk.tagName=='BODY' || lnk.tagName=='body') {
			return false;
		} else if (lnk.tagName=='P' || lnk.tagName=='p') {
			return true;
		} else {
			return OAT.Moz.LinkedData.isInParagraph(lnk.parentNode);
		}
	},

	doLink:function(elem) { /* append a++ onto elements */
		if (!elem) return;
		
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var ds = prefs.getIntPref("extensions.linkeddata.displaystyle");

		if (ds==2 || ds==3) {
			var icon = new Image();
			icon.src = 'chrome://linkeddata/content/img/l.png';
			icon.style.marginLeft = '1px';
			icon.style.marginBottom = '2px';
			elem.parentNode.insertBefore(icon, elem.nextSibling);
			var target = icon;
		} else if (ds==1) {
			elem.style.borderBottom = '1px double';
			var target = elem;
		}

		if (ds==1 || ds==2) {
			var activation = "hover";
		} else {
			icon.style.cursor = 'pointer';
			var activation = "click";
		}

		var div = OAT.Dom.create("div");
		var obj = {
				title:"Linked Data",
				content:OAT.Dom.text(""),
				status:"Source:&nbsp;&lt;"+elem.href+"&gt;",
				result_control:false,
				activation:activation,
				type:OAT.WinData.TYPE_ODS,
				uri:elem.href,
				newHref:elem.href
			};
		OAT.Anchor.assign(target,obj);

	},

	getSubmittingLinksHTML:function(uri) {
			var title = window.top.getBrowser().selectedBrowser.contentDocument.title;

			var defaulttext = "this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='"+uri+"'";

			var submitter = window.top.getBrowser().selectedBrowser.contentDocument.createElement('div');
			submitter.setAttribute('class','oat_linkeddata_submitter');

			var delicious = new Image();
			delicious.src = 'chrome://linkeddata/content/img/icon_delicious.gif';
			delicious.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Submit this link to del.icio.us'");
			delicious.setAttribute('onmouseout',defaulttext);
			delicious.setAttribute('onclick',"window.open('http://del.icio.us/post?url="+uri+"')");
			delicious.setAttribute('id','linkeddata_delicious');
			submitter.appendChild(delicious);

			var slashdot = new Image();
			slashdot.src = 'chrome://linkeddata/content/img/icon_slashdot.png';
			slashdot.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Submit this link to Slashdot'");
			slashdot.setAttribute('onmouseout',defaulttext);
			slashdot.setAttribute('onclick',"window.open('http://slashdot.org/bookmark.pl?url="+uri+"')");
			slashdot.setAttribute('id','linkeddata_delicious');
			submitter.appendChild(slashdot);

			var digg = new Image();
			digg.src = 'chrome://linkeddata/content/img/icon_digg.gif';
			digg.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Submit this link to Digg It!'");
			digg.setAttribute('onmouseout',defaulttext);
			digg.setAttribute('onclick',"window.open('http://www.digg.com/submit?phase=2&url="+uri+"')");
			digg.setAttribute('id','linkeddata_delicious');
			submitter.appendChild(digg);

			var newsvine = new Image();
			newsvine.src = 'chrome://linkeddata/content/img/icon_newsvine.gif';
			newsvine.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Submit this link to Newsvine'");
			newsvine.setAttribute('onmouseout',defaulttext);
			newsvine.setAttribute('onclick',"window.open('http://www.newsvine.com/_tools/seed&save?u="+uri+"')");
			submitter.appendChild(newsvine);

			var facebook = new Image();
			facebook.src = 'chrome://linkeddata/content/img/icon_facebook.gif';
			facebook.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Submit this link to Facebook'");
			facebook.setAttribute('onmouseout',defaulttext);
			facebook.setAttribute('onclick',"window.open('http://www.facebook.com/sharer.php?u="+uri+"')");
			submitter.appendChild(facebook);

			var reddit = new Image();
			reddit.src = 'chrome://linkeddata/content/img/icon_reddit.gif';
			reddit.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Submit this link to Reddit'");
			reddit.setAttribute('onmouseout',defaulttext);
			reddit.setAttribute('onclick',"window.open('http://reddit.com/submit?url="+uri+"')");
			submitter.appendChild(reddit);

			var rdfb = new Image();
			rdfb.src = 'chrome://linkeddata/content/img/RDF_rdf.png';
			rdfb.setAttribute('onmouseover',"this.parentNode.parentNode.parentNode.childNodes[2].innerHTML='Explore this URI in RDFBrowser'");
			rdfb.setAttribute('onmouseout',defaulttext);
			rdfb.setAttribute('onclick',"window.open('http://demo.openlinksw.com/rdfbrowser2/?uri="+uri+"')");
			submitter.appendChild(rdfb);
			return submitter;
	},

	getHref:function(link) { /* return absolute path */
		if (link[i].href.substr(0,7)=='http://' || link[i].href.substr(0,8)=='https://') {
			return link;
		} else {
			var loc = window.top.getBrowser().selectedBrowser.location;
			return loc.protocol + loc.host + link;
		}
	},

	insertAfter:function(newChild, refChild) {
		refChild.parentNode.insertBefore(newChild,refChild.nextSibling);
	}

};

window.addEventListener("load", function(e) { OAT.Moz.LinkedData.onLoad(e); }, false); 

window.top.getBrowser().tabContainer.addEventListener("TabOpen", function(e) {
	setTimeout(function(e) { OAT.Moz.LinkedData.onLoad(e); }, 2000);
}, false);


