/**
*	Preferences for Linked Data
*/

if (!OAT) var OAT = { Moz:{ LinkedData:{} } };


OAT.Moz.LinkedData.loadPrefs = function() {

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	var enabled = prefs.getBoolPref("extensions.linkeddata.enabled");
	var rdfb = prefs.getBoolPref("extensions.linkeddata.rdfb");
	var linksubmitting = prefs.getBoolPref("extensions.linkeddata.linksubmitting");
	var endpoint = prefs.getCharPref("extensions.linkeddata.defaultendpoint");
	var scope = prefs.getCharPref("extensions.linkeddata.scope");
	var spongeropts = prefs.getCharPref("extensions.linkeddata.spongeroptions");
	var displaystyle = prefs.getIntPref("extensions.linkeddata.displaystyle");

	document.getElementById('linkeddata-prefs-enabled').setAttribute('checked', enabled);
	document.getElementById('linkeddata-prefs-rdfb').setAttribute('checked', rdfb);
	document.getElementById('linkeddata-prefs-linksubmitting').setAttribute('checked', linksubmitting);
	document.getElementById('linkeddata-prefs-scope-'+scope).setAttribute('selected', true);
	
	var endpoints = ["http://demo.openlinksw.com/sparql", "http://ec2-67-202-25-143.compute-1.amazonaws.com:8890/sparql"];

	var menuitem = document.createElement('menuitem');
	menuitem.setAttribute('label', endpoint);
	menuitem.setAttribute('value', endpoint);
	document.getElementById('linkeddata-prefs-defaultendpoint-items').appendChild(menuitem);

	for (i in endpoints) {
		if (endpoint == endpoints[i])
			continue;
		var menuitem = document.createElement('menuitem');
		menuitem.setAttribute('label', endpoints[i]);
		menuitem.setAttribute('value', endpoints[i]);
		document.getElementById('linkeddata-prefs-defaultendpoint-items').appendChild(menuitem);
	}
	document.getElementById('linkeddata-prefs-defaultendpoint').selectedIndex = 0;
	
	var so = document.getElementById('linkeddata-prefs-spongeroptions');
	for (var i=0; i<so.itemCount; i++) {
		if (so.getItemAtIndex(i).value==spongeropts)
			so.selectedIndex = i;
	}
	
	var ds = document.getElementById('linkeddata-prefs-displaystyle');
	for (var i=0; i<ds.itemCount; i++) {
		if (ds.getItemAtIndex(i).value==displaystyle)
			ds.selectedIndex = i;
	}

	/* disable scope when turned off */
	if (!enabled) {
		document.getElementById('linkeddata-prefs-scope-paragraphs').setAttribute("disabled",true);
		document.getElementById('linkeddata-prefs-scope-all').setAttribute("disabled",true);
		document.getElementById('linkeddata-prefs-rdfb').setAttribute("disabled",true);
		document.getElementById('linkeddata-prefs-linksubmitting').setAttribute("disabled",true);
	}
}


OAT.Moz.LinkedData.savePrefs = function() {

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	prefs.setBoolPref("extensions.linkeddata.enabled", document.getElementById('linkeddata-prefs-enabled').checked);
	prefs.setBoolPref("extensions.linkeddata.rdfb", document.getElementById('linkeddata-prefs-rdfb').checked);
	prefs.setBoolPref("extensions.linkeddata.linksubmitting", document.getElementById('linkeddata-prefs-linksubmitting').checked);
	prefs.setCharPref("extensions.linkeddata.defaultendpoint", document.getElementById('linkeddata-prefs-defaultendpoint').label);
	prefs.setCharPref("extensions.linkeddata.scope", document.getElementById('linkeddata-prefs-scope').selectedItem.value);
	prefs.setCharPref("extensions.linkeddata.spongeroptions",document.getElementById('linkeddata-prefs-spongeroptions').selectedItem.value);
	prefs.setIntPref("extensions.linkeddata.displaystyle",document.getElementById('linkeddata-prefs-displaystyle').selectedItem.value);

}

OAT.Moz.LinkedData.disablePrefsCtrls = function(val) {
	if (val) {
		document.getElementById('linkeddata-prefs-scope-paragraphs').setAttribute("disabled",true);
		document.getElementById('linkeddata-prefs-scope-all').setAttribute("disabled",true);
		document.getElementById('linkeddata-prefs-rdfb').setAttribute("disabled",true);
		document.getElementById('linkeddata-prefs-linksubmitting').setAttribute("disabled",true);
	} else {
		document.getElementById('linkeddata-prefs-scope-paragraphs').setAttribute("disabled",false);
		document.getElementById('linkeddata-prefs-scope-all').setAttribute("disabled",false);
		document.getElementById('linkeddata-prefs-rdfb').setAttribute("disabled",false);
		document.getElementById('linkeddata-prefs-linksubmitting').setAttribute("disabled",false);
	}
}