/**
*	Preferences for ODE
*/

if (!OAT) var OAT = { Moz:{ ODE:{} } };

//
// Recursively apply method on elem_nodes
//

OAT.Moz.ODE.applyR = function(_n, _method, _args) {
	
    if (_n.nodeType == Node.ELEMENT_NODE && _n[_method]) 
	_n[_method].apply(_n, _args);
    
    if (!_n.hasChildNodes) return;

    var _cNodes = _n.childNodes;
    
    for (var i = 0; i < _cNodes.length; i++)
	{
	    OAT.Moz.ODE.applyR (_cNodes[i], _method, _args);
	}
};

//
// Trim strings
//

String.prototype.trim = function () {
    return this.replace(/^\s*/, "").replace(/\s*$/, "");
};

OAT.Moz.ODE.loadPrefs = function() {


    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    /*    var num_cld = {};
    var c_list = prefs.getChildList("extensions.ode.", num_cld);
    var i;

    for (i in c_list) {
    	if (prefs.prefHasUserValue (c_list[i]))
    	    prefs.clearUserPref (c_list[i]);
    }
    */
    // Viewer type:
    // ode (default), zitgist, marbles, disco, tabulator, custom
    //
    
    var viewertype        = prefs.getCharPref("extensions.ode.viewertype");
    var viewerendpoint    = prefs.getCharPref("extensions.ode.viewerendpoint");
    
    /* Init viewer list */

    var list = document.getElementById('ode-prefs-viewer').getElementsByTagName('menuitem');

    for (i in list) {
	if (list[i].value == viewertype)
	    document.getElementById('ode-prefs-viewer').selectedIndex = i;
    }

    document.getElementById('ode-prefs-viewer-custom-url').setAttribute('value', viewerendpoint);
    
    // Opening behaviour for ODE viewer
    //    
    // IF Viewer = ODE, controls viewer and cache reuse
    // Values:  Add, Replace, New
    //
    
    var openingbehavior   = prefs.getCharPref("extensions.ode.openingbehavior");

    document.getElementById('ode-prefs-opening-add').setAttribute('selected', false);
    document.getElementById('ode-prefs-opening-replace').setAttribute('selected', false);
    document.getElementById('ode-prefs-opening-new').setAttribute('selected', false);
    document.getElementById('ode-prefs-opening-'+openingbehavior).setAttribute('selected', true);

    //
    // SPARQL Endpoint - only used by viewer ODE
    //

    var sparqltype         = prefs.getCharPref("extensions.ode.sparqltype");
    var sparqlhost         = prefs.getCharPref("extensions.ode.sparqlhost");
    var sparqlport         = prefs.getCharPref("extensions.ode.sparqlport");

    var sparqlgenendpoint  = prefs.getCharPref("extensions.ode.sparqlgenendpoint");
    var sparqlcustendpoint = prefs.getCharPref("extensions.ode.sparqlcustendpoint");

    var sparqlendpointsigs = [	"http://%s:%s/sparql",
				                "http://ec2-67-202-25-143.compute-1.amazonaws.com:8890/sparql",
				                "http://127.0.0.1/sparql" ];

    var slist = document.getElementById('ode-prefs-sparql-type').getElementsByTagName('menuitem');

    for (i in slist) {
	if (slist[i].value == sparqltype)
	    document.getElementById('ode-prefs-sparql-type').selectedIndex = i;
    }

    /* Endpoint */

    document.getElementById('ode-prefs-sparql-host').setAttribute('value', sparqlhost);
    document.getElementById('ode-prefs-sparql-port').setAttribute('value', sparqlport);
    document.getElementById('ode-prefs-sparql-cust-url').setAttribute('value', sparqlcustendpoint);


    // proxyservice - the service producing RDF
    // values: virtuoso, triplr, custom
    // 
    // virtuoso, triplr have their default values for service endpoint, retrieved by set default button
    // for virtuoso we point to http://demo.openlinksw.com/proxy/rdf/[URL to triplify]
    // for triplr we have http://triplr.org/rdf/[URL to triplify]
    //
    
    var proxyservice      = prefs.getCharPref("extensions.ode.proxyservice"); // type of service

    var proxyhost         = prefs.getCharPref("extensions.ode.proxyhost");
    var proxyport         = prefs.getCharPref("extensions.ode.proxyport");
    var proxygenendpoint  = prefs.getCharPref("extensions.ode.proxygenendpoint");

    var proxycustendpoint = prefs.getCharPref("extensions.ode.proxycustendpoint");

    var proxyendpointsigs = [	"http://linkeddata.uriburner.com/about?url=",
                                "http://%s:%s/about/rdf/%s",
    				            "http://triplr.org/rdf/%s" ];


    var rs = document.getElementById('ode-prefs-proxyservice').getElementsByTagName('menuitem');

    document.getElementById('ode-prefs-proxyservice').selectedIndex = 0; // in case no settings are in preferences

    for (i in rs) {
	if (rs[i].value == proxyservice)
	    document.getElementById('ode-prefs-proxyservice').selectedIndex = i;
    }

    document.getElementById('ode-prefs-proxy-host').setAttribute('value', proxyhost);
    document.getElementById('ode-prefs-proxy-port').setAttribute('value', proxyport);
    document.getElementById('ode-prefs-proxy-custom-url').setAttribute('value', proxycustendpoint);
    
    /* disable or enable features */
    OAT.Moz.ODE.enableCtrls();
};
    


OAT.Moz.ODE.setSparqlDefaults = function() {
    document.getElementById('ode-prefs-sparql-host').value='linkeddata.uriburner.com';
    document.getElementById('ode-prefs-sparql-port').value='80';
};

OAT.Moz.ODE.setProxyDefaults = function() {
    document.getElementById('ode-prefs-proxy-host').value='linkeddata.uriburner.com';
    document.getElementById('ode-prefs-proxy-port').value='80';
};

OAT.Moz.ODE.testSparqlEndPoint = function() {
    var host = document.getElementById ('').value;
    var port = document.getElementById ('').value;
    //    var endPoint = 
};

OAT.Moz.ODE.testProxyEndPoint = function() {
    var host = document.getElementById ('').value;
    var port = document.getElementById ('').value;
};

OAT.Moz.ODE.testProxyEndPoint2 = function () {
    
    //    var host = 

};

OAT.Moz.ODE.enableCtrls = function() {

    document.getElementById('ode-prefs-viewer-opts-bcast').setAttribute('disabled', true);
    document.getElementById('ode-prefs-viewer-custom-url-bcast').setAttribute('hidden', true);
    document.getElementById('ode-prefs-sparql-endpoint-hostport-bcast').setAttribute('disabled', true);
    document.getElementById('ode-prefs-sparql-custom-url-bcast').setAttribute('hidden', true);
    document.getElementById('ode-prefs-proxy-custom-url-bcast').setAttribute('hidden', true);
    
    OAT.Moz.ODE.applyR (document.getElementById('ode-prefs-sparql-endpoint-options'), 'setAttribute', ['disabled', true]);
    
    switch (document.getElementById('ode-prefs-viewer').value) {
      case 'builtin':
	document.getElementById('ode-prefs-viewer-opts-bcast').removeAttribute('disabled');
	document.getElementById('ode-prefs-sparql-endpoint-hostport-bcast').removeAttribute('disabled');
	OAT.Moz.ODE.applyR (document.getElementById('ode-prefs-sparql-endpoint-options'), 'removeAttribute', ['disabled']);
	
	switch (document.getElementById('ode-prefs-sparql-type').value) {
	    
	  case 'virtuoso':
	    document.getElementById('ode-prefs-sparql-endpoint-hostport-bcast').removeAttribute('hidden');
	    document.getElementById('ode-prefs-sparql-custom-url-bcast').setAttribute('hidden', true);
	    break;
	
	  case 'custom':
	    document.getElementById('ode-prefs-sparql-endpoint-hostport-bcast').setAttribute('hidden', true);
	    document.getElementById('ode-prefs-sparql-custom-url-bcast').removeAttribute('hidden');
	    break;
	}

        break;

      case 'custom':
	document.getElementById('ode-prefs-viewer-opts-bcast').setAttribute('disabled', true);
	document.getElementById('ode-prefs-viewer-custom-url-bcast').removeAttribute('hidden');
	break;
    };

    switch (document.getElementById('ode-prefs-proxyservice').value) {

    case 'virtuoso':
	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').removeAttribute('disabled'); 
	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').removeAttribute('hidden'); 
	document.getElementById('ode-prefs-proxy-custom-url-bcast').setAttribute('hidden', true);
	break;
	//    case 'virt-simple':
	//	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').removeAttribute('disabled'); 
	//	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').removeAttribute('hidden'); 
	//	document.getElementById('ode-prefs-proxy-custom-url-bcast').setAttribute('hidden', true);
	//	break;
    case 'triplr':
	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').removeAttribute('hidden'); 
	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').setAttribute('disabled',true); 
	document.getElementById('ode-prefs-proxy-custom-url-bcast').setAttribute('hidden', true);
        break;
    case 'custom':
	document.getElementById('ode-prefs-proxy-endpoint-hostport-bcast').setAttribute('hidden',true); 
	document.getElementById('ode-prefs-proxy-custom-url-bcast').removeAttribute('hidden');
	break;
    }
};

OAT.Moz.ODE.savePrefs = function() {

    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    // Viewer

    var viewer_endpoints = ['http://linkeddata.uriburner.com/ode/?uri[]=', 
			    'http://dataviewer.zitgist.com/?uri=',
			    'http://beckr.org/marbles?uri=',
			    'http://www4.wiwiss.fu-berlin.de/rdf_browser/?browse_uri=',
			    'http://dig.csail.mit.edu/2005/ajar/release/tabulator/0.8/tab.html?uri='];


    var _e = document.getElementById('ode-prefs-viewer');

    prefs.setCharPref("extensions.ode.viewertype", _e.value);

    if (_e.value != 'custom') 
	prefs.setCharPref("extensions.ode.viewerendpoint", viewer_endpoints[_e.selectedIndex]);
    else
	prefs.setCharPref("extensions.ode.viewerendpoint", document.getElementById('ode-prefs-viewer-custom-url').value);

    prefs.setCharPref("extensions.ode.openingbehavior", document.getElementById('ode-prefs-opening').selectedItem.value);

    // SPARQL Endpoint

    prefs.setCharPref("extensions.ode.sparqltype", document.getElementById('ode-prefs-sparql-type').value);

    var _s_host = document.getElementById('ode-prefs-sparql-host').value.trim();
    var _s_port = document.getElementById('ode-prefs-sparql-port').value.trim();

    prefs.setCharPref("extensions.ode.sparqlhost", _s_host);
    prefs.setCharPref("extensions.ode.sparqlport", _s_port);

    var _gen_ep;

    if (document.getElementById('ode-prefs-sparql-type').value != 'custom') {
	if (_s_port != '')
	    _gen_ep = "http://" + _s_host + ":" + _s_port + "/sparql";
	else
	    _gen_ep = "http://" + _s_host + "/sparql";
    } 
    else
	_gen_ep = document.getElementById('ode-prefs-sparql-cust-url').value;

    prefs.setCharPref("extensions.ode.sparqlgenendpoint", _gen_ep);
    prefs.setCharPref("extensions.ode.sparqlcustendpoint", document.getElementById('ode-prefs-sparql-cust-url').value);

    // Proxy

    var _p_s_elm = document.getElementById('ode-prefs-proxyservice');

    prefs.setCharPref ("extensions.ode.proxyservice", _p_s_elm.value);

    var _p_host = document.getElementById('ode-prefs-proxy-host').value.trim();
    var _p_port = document.getElementById('ode-prefs-proxy-port').value.trim();

    prefs.setCharPref ("extensions.ode.proxyhost", _p_host);
    prefs.setCharPref ("extensions.ode.proxyport", _p_port);

    switch (_p_s_elm.value) {
      case 'virt_simple':
	  if (_p_port != '') 
	      _gen_p_ep = 'http://' + _p_host + ':' + _p_port + '/about/rdf/';
	  else 
	      _gen_p_ep =  'http://' + _p_host + '/about/rdf/';
	  break;
      case 'virtuoso':
	  if (_p_port != '')
	      _gen_p_ep = 'http://' + _p_host + ':' + _p_port + '/about/?url=';
	  else 
	      _gen_p_ep = 'http://' + _p_host + '/about/?url=';
	  break;
      case 'triplr':
	_gen_p_ep = 'http://triplr.org/rdf/';
	break;
      case 'custom':
	_gen_p_ep = document.getElementById('ode-prefs-proxy-custom-url').value;
    }

    prefs.setCharPref ("extensions.ode.proxygenendpoint", _gen_p_ep);
    prefs.setCharPref ("extensions.ode.proxycustendpoint", document.getElementById('ode-prefs-proxy-custom-url').value);
}

