var urls = {};

var Url = function(url,notify) {
	var self = this;
	this.url = url;
	this.notify = notify;
	this.wakeupTime = false;
	
	this.remove = function() {
		delete urls[self.url];
		OAT.Dom.unlink(self.div);
	}

	var remove = OAT.Dom.create("a");
	remove.innerHTML = "X";
	remove.href = "#";
	OAT.Event.attach(remove,"click",self.remove);
	
	this.div = OAT.Dom.create("div");
	var a = OAT.Dom.create("a");
	a.href = url;
	a.innerHTML = url;
	
	this.throbber = OAT.Dom.create("img");
	this.throbber.src = OAT.Preferences.imagePath + "Dav_throbber.gif";
	OAT.Dom.hide(self.throbber);
	
	this.status = OAT.Dom.create("span");
	self.status.innerHTML = "initializing";
	
	OAT.Dom.append(["results",self.div],[self.div,OAT.Dom.text("["),remove,OAT.Dom.text("] "),a,OAT.Dom.text(" "),self.throbber,OAT.Dom.text(" "),self.status]);
	
	this.parseExpires = function(str) {
		return new Date(str.trim());
	}
	
	this.parseCache = function(str) {
		var r = str.match(/max-age=([0-9]+)/);
		if (!r) { return false; }
		var sec = parseInt(r[1]);
		var d = new Date();
		d.setTime(d.getTime() + 1000*sec);
		return d;
	}
	

	this.cb = function(data,headers) {
		var pos;
		var content = OAT.Dom.create("div");
		var s = OAT.Dom.create("strong");
		s.innerHTML = self.url;
		OAT.Dom.append([content,s,OAT.Dom.create("br"),OAT.Dom.text("New data!")]);
		self.notify.send(content,{timeout:3000});
		
		self.headers = headers;
		var h = headers.split("\n");
		var date1 = false;
		var date2 = false;
		for (var i=0;i<h.length;i++) {
			var header = h[i];
			if (!header) { continue; }
			var pos = header.indexOf(":");
			var parts = ["",""];
			parts[0] = header.substring(0,pos);
			parts[1] = header.substring(pos+1);
			if (parts[0] == "Expires") { date1 = self.parseExpires(parts[1]); }
			if (parts[0] == "Cache-Control") { date2 = self.parseCache(parts[1]); }
		}
		var date = new Date();
		if (!date1 && !date2) {
			self.wakeupTime = false;
			self.status.innerHTML = "no expiration set, checking disabled";
		} else { 
			var d = false;
			if (date1) {
				var t = date1.getTime();
				if (!d || t < d.getTime()) { d = date1; }
			}
			if (date2) {
				var t = date2.getTime();
				if (!d || t < d.getTime()) { d = date2; }
			}
			if (d.getTime() <= date.getTime()) {
				/* in past */
				var sec = 10;
				date.setTime(date.getTime() + 1000*sec);
				self.wakeupTime = date; /* after 10 sec */
				self.status.innerHTML = "already expired, check in "+sec+" seconds";
			} else {
				/* in future */
				self.wakeupTime = d;
				self.status.innerHTML = "expires on "+d;
			}
		}
	}
	
	this.check = function() {
		self.wakeupTime = false; /* prevent further checks until solved */
		var o = {
			onstart:function() { OAT.Dom.show(self.throbber); },
			onend:function() { OAT.Dom.hide(self.throbber); }
		}
		var enc = encodeURIComponent(self.url);
		var path = (self.url.match(/^http/i) ? "/proxy?url="+enc : self.url);
		OAT.AJAX.GET(path,false,self.cb,o);
	}
}

var add = function(notify) {
	var url = $v("inp");
	if (url in urls) { 
		alert("We already have this!");
		return;
	}
	var obj = new Url(url,notify);
	urls[url] = obj;
	obj.check();
}

var timeout = 1000*5; /* 5 sec */

function globalChecker() {
	var d = new Date();
	var t = d.getTime();
	for (var p in urls) {
		var item = urls[p];
		if (item.wakeupTime && item.wakeupTime.getTime() <= t) { item.check(); }
	}
	setTimeout(globalChecker,timeout);
}

function init() {
	/* init notification area */
	var notify = new OAT.Notify();

	OAT.Event.attach("btn","click",add);
	OAT.Event.attach("inp","keypress",function(event){
		if (event.keyCode == 13) { add(notify); }
	});
	globalChecker();
	
	/**/
	$("inp").value = "http://www.bbc.co.uk/"; add(notify);
	$("inp").value = "http://www.cnn.com/"; add(notify);
	$("inp").value = "";
	/**/
	
}
